commit ba26c471cf6ee760e53836fd4e9bc00250b8b882
Author: John David Anglin <danglin@gcc.gnu.org>
Date:   Tue Aug 6 19:40:26 2024

    hppa: Fix (plus (plus (mult (a) (mem_shadd_constant)) (b)) (c)) optimization
    
    The constant C must be an integral multiple of the shift value in
    the above optimization.  Non integral values can occur evaluating
    IMAGPART_EXPR when the shadd constant is 8 and we have SFmode.
    
    2024-08-06  John David Anglin  <danglin@gcc.gnu.org>
    
    gcc/ChangeLog:
    
            PR target/113384
            * config/pa/pa.cc (hppa_legitimize_address): Add check to
            ensure constant is an integral multiple of shift the value.

diff --git a/gcc/config/pa/pa.cc b/gcc/config/pa/pa.cc
index a7af6b8c121..b24434628fa 100644
--- a/gcc/config/pa/pa.cc
+++ b/gcc/config/pa/pa.cc
@@ -1407,6 +1407,7 @@ hppa_legitimize_address (rtx x, rtx oldx ATTRIBUTE_UNUSED,
       /* If the index adds a large constant, try to scale the
 	 constant so that it can be loaded with only one insn.  */
       if (GET_CODE (XEXP (idx, 1)) == CONST_INT
+	  && INTVAL (XEXP (idx, 1)) % (1 << shift_val) == 0
 	  && VAL_14_BITS_P (INTVAL (XEXP (idx, 1))
 			    / INTVAL (XEXP (XEXP (idx, 0), 1)))
 	  && INTVAL (XEXP (idx, 1)) % INTVAL (XEXP (XEXP (idx, 0), 1)) == 0)

